using System;
using System.IO;
using System.Text;
using System.Reflection;
using System.Collections.Generic;
using System.Data;
using System.Text.RegularExpressions;
using System.Threading;
using System.Timers;

using PRoCon.Core;
using PRoCon.Core.Plugin;
using PRoCon.Core.Plugin.Commands;
using PRoCon.Core.Players;
using PRoCon.Core.Players.Items;
using PRoCon.Core.Battlemap;
using PRoCon.Core.Maps;
using PRoCon.Core.HttpServer;

namespace PRoConEvents {
    public class CModReload : PRoConPluginAPI, IPRoConPluginInterface {
		
		private string m_strModReloadCommand;
		
        private bool m_isPluginEnabled;
		
		
		
        public CModReload() {

			this.m_strModReloadCommand = "modreload";
			
            this.m_isPluginEnabled = false;
        }

        public string GetPluginName() {
            return "ModList ReloadExtensions Plugin";
        }

        public string GetPluginVersion() {
            return "1.0.0";
        }

        public string GetPluginAuthor() {
            return "Bree_Arnold";
        }

        public string GetPluginWebsite() {
            return "http://playvu.com";
        }

        public string GetPluginDescription() {
            return @"
<h2>Description</h2>
    <p>Provides a command to use modList.reloadExtensions in-game.</p>

<h2>Commands</h2>
    <blockquote><h4>@modreload</h4>for modList.reloadExtensions</blockquote>";
        }

        public void OnPluginLoaded(string strHostName, string strPort, string strPRoConVersion) {
			
			this.RegisterEvents(this.GetType().Name, "OnRegisteredCommand", "OnUnregisteredCommand" );
        }

        public void OnPluginEnable() {
            this.ExecuteCommand("procon.protected.pluginconsole.write", "^bModList ReloadExtensions Plugin ^2Enabled!");

			
            this.m_isPluginEnabled = true;
            this.RegisterAllCommands();
        }

        public void OnPluginDisable() {
            this.ExecuteCommand("procon.protected.pluginconsole.write", "^bModList ReloadExtensions Plugin ^1Disabled!" );

            this.m_isPluginEnabled = false;
            this.UnregisterAllCommands();
        }

        public List<CPluginVariable> GetDisplayPluginVariables() {

            List<CPluginVariable> lstReturn = new List<CPluginVariable>();
			lstReturn.Add(new CPluginVariable("Commands|ModReload", this.m_strModReloadCommand.GetType(), this.m_strModReloadCommand));
			
            return lstReturn;
        }

        public List<CPluginVariable> GetPluginVariables() {
            return GetDisplayPluginVariables();
        }

        public void SetPluginVariable(string strVariable, string strValue) {
			if (strVariable.CompareTo("ModReload") == 0) {
				this.m_strModReloadCommand = strValue;
			}
            this.RegisterAllCommands();
        }

        private void UnregisterAllCommands() {
            
			this.UnregisterCommand(new MatchCommand("CModReload", "OnCommandModReload", this.Listify<string>("@", "!", "#"), this.m_strModReloadCommand, this.Listify<MatchArgumentFormat>(), new ExecutionRequirements(ExecutionScope.All), "for modList.reloadExtensions"));
		}
       
        private void RegisterAllCommands() {

            if (this.m_isPluginEnabled == true) {
                
                this.RegisterCommand(new MatchCommand("CModReload", "OnCommandModReload", this.Listify<string>("@", "!", "#"), this.m_strModReloadCommand, this.Listify<MatchArgumentFormat>(), new ExecutionRequirements(ExecutionScope.All), "for modList.reloadExtensions"));
			}
		}
		
		#region commands
				
		public void OnCommandModReload(string strSpeaker, string strText, MatchCommand mtcCommand, CapturedCommand capCommand, CPlayerSubset subMatchedScope) {
			this.ExecuteCommand("procon.protected.send", "modList.ReloadExtensions");
        }
		
		#endregion
	}
}