using System;
using System.IO;
using System.Text;
using System.Reflection;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Text.RegularExpressions;
using System.Threading;
using System.Timers;

using PRoCon.Core;
using PRoCon.Core.Plugin;
using PRoCon.Core.Plugin.Commands;
using PRoCon.Core.Players;
using PRoCon.Core.Players.Items;
using PRoCon.Core.TextChatModeration;
using PRoCon.Core.Battlemap;
using PRoCon.Core.Maps;
using PRoCon.Core.HttpServer;

namespace PRoConEvents {
	
	public class CTestAPIEvents : PRoConPluginAPI, IPRoConPluginInterface {
		bool m_isPluginEnabled;
		public CTestAPIEvents (){
            this.m_isPluginEnabled = false;
		}
		
		public string GetPluginName() {
            return "CTestAPIEvents";
        }
		
		public string GetPluginVersion() {
            return "1.0";
        }
		
        public string GetPluginAuthor() {
            return "Flash_Hit";
        }
		
        public string GetPluginWebsite() {
            return "battlelog.battlefield.com/bf3/platoon/3307924585064219629/";
        }
		
		public string GetPluginDescription() {
            return @"
<h2>Description</h2>
    <p>CTestAPIEvents.</p>";
        }
		
		public void OnPluginLoaded(string strHostName, string strPort, string strPRoConVersion) {
			
			this.RegisterEvents(this.GetType().Name, "OnModListDebug", "OnModListList", "OnModListAvailableMods", "OnPlayerGet", "OnFrequencyMode", "OnSquadSize", "OnUnlockListList", "OnVuEvent", "OnUnlockListSet", "OnUnlockListRemove", "OnUnlockListAdd", "OnUnlockMode", "OnPlayerIsDead", "OnPlayerIsRevivable", "OnTextChatModerationLoad", "OnTextChatModerationList", "OnTextChatModerationClear", "OnTextChatModerationRemovePlayer", "OnTextChatModerationAddPlayer");
        }
		
		public void OnPluginEnable() {
            this.ExecuteCommand("procon.protected.pluginconsole.write", "^bCTestAPIEvents ^2Enabled!");
            this.m_isPluginEnabled = true;
        }

        public void OnPluginDisable() {
            this.ExecuteCommand("procon.protected.pluginconsole.write", "^bCTestAPIEvents ^1Disabled!" );

            this.m_isPluginEnabled = false;
        }
		
		public List<CPluginVariable> GetDisplayPluginVariables() {

            List<CPluginVariable> lstReturn = new List<CPluginVariable>();
			
            return lstReturn;
        }

        public List<CPluginVariable> GetPluginVariables() {
			
            List<CPluginVariable> lstReturn = new List<CPluginVariable>();
			
            return GetDisplayPluginVariables();
        }
		
		public void SetPluginVariable(string strVariable, string strValue) {
			
        }
		public void OnModListAvailableMods(List<string> lstAvailableMods) { 
			string together = "";
			foreach(string item in lstAvailableMods){
				together = together + " " + item;
			}
			this.ExecuteCommand("procon.protected.pluginconsole.write", "OnModListAvailableMods:" + together);
		}
		public void OnModListList(List<string> lstMods) { 
			string together = "";
			foreach(string item in lstMods){
				together = together + " " + item;
			}
			this.ExecuteCommand("procon.protected.pluginconsole.write", "OnModListList:" + together);
		}
		public void OnModListDebug(bool enabled) { 
			this.ExecuteCommand("procon.protected.pluginconsole.write", "OnModListDebug");
		}
		public void OnTextChatModerationLoad() { 
			
		}
		public void OnTextChatModerationAddPlayer(TextChatModerationEntry playerEntry) { 
			
		}
        public void OnTextChatModerationRemovePlayer(TextChatModerationEntry playerEntry) { 
			
		}
        public void OnTextChatModerationClear() { 
			
		}
        public void OnTextChatModerationList(TextChatModerationDictionary moderationList) { 	
			
		}
		public void OnPlayerIsDead(string soldierName, bool isDead){
			 this.ExecuteCommand("procon.protected.pluginconsole.write", "OnPlayerIsDead: "+soldierName+" "+isDead.ToString());
		}
		public void OnUnlockMode(string mode){
			 this.ExecuteCommand("procon.protected.pluginconsole.write", "OnUnlockMode: "+mode);
		}
		public void OnUnlockListAdd(string strUnlockListAdd){
			 this.ExecuteCommand("procon.protected.pluginconsole.write", "OnUnlockListAdd: "+strUnlockListAdd);
		}
		public void OnUnlockListRemove(string strUnlockListRemove){
			 this.ExecuteCommand("procon.protected.pluginconsole.write", "OnUnlockListRemove: "+strUnlockListRemove);
		}
		public void OnUnlockListList(List<string> lstUnlocklist){
			string together = "";
			foreach(string item in lstUnlocklist){
				together = together + " " + item;
			}
			this.ExecuteCommand("procon.protected.pluginconsole.write", "OnUnlockListList:" + together);
		}
		public void OnUnlockListSet(List<string> lstUnlocklistSet){
			string together = "";
			foreach(string item in lstUnlocklistSet){
				together = together + " " + item;
			}
			this.ExecuteCommand("procon.protected.pluginconsole.write", "OnUnlockListSet:" + together);
		}
		public void OnVuEvent(string strEventName, bool enabled){
			this.ExecuteCommand("procon.protected.pluginconsole.write", "OnVuEvent: "+strEventName+ " "+enabled.ToString());
		}
		public void OnSquadSize(int squadSize){
			this.ExecuteCommand("procon.protected.pluginconsole.write", "OnSquadSize: "+squadSize.ToString());
		}
		public void OnFrequencyMode(string strFrequencyMode){
			this.ExecuteCommand("procon.protected.pluginconsole.write", "OnFrequencyMode: " + strFrequencyMode);
			
			this.ExecuteCommand("procon.protected.send", "player.isDead", "voteban_flash");
		}
		public void OnPlayerGet(string strPlayerName, int playerId, int playerOnlineId, string strPlayerGuid, string strAccoutGuid, string strPlayerIp, int ping, bool isAlive, bool isSquadLeader, bool isSquadPrivate, bool hasSoldier, int teamId, int squadId, bool isAllowedToSpawn, int score, int kills, int deaths, string strPrimaryWeapon, string strOptic, string strPrimaryAccessory, string strSecondaryAccessory, string strSecondaryWeapon, string strGadget_1, string strGadget_2, string strGrenade, string strKnife, string strSpecialization, float position_x, float position_y, float position_z, float health, bool isDead) 
		{
			this.ExecuteCommand("procon.protected.pluginconsole.write", "OnPlayerGet: " + strPlayerName +" "+ playerId);
		}
	}
}